#|<--                          80 columns                                               ->|#

(let ((time-stamp "Time-stamp: <03/06/27 20:09:00 kazu>"))
  (display (string-append "tests=padflow.scm:  " (substring time-stamp 13 29)))
  (newline))

(load "tests=paex.scm")

(define view-and-bean-class-decls
  (lambda ()
    '((class view object 
	     (method void   init   () (super init))
	     (method string input  () "dirty")
	     (method void   print  ((string s)) (write s))
	     (method void   makeview ((string s))
		     (send this print "makeview:")(newline)
		     (send this print s)(newline))
	     (method void   makeview-with-userbean ((userbean ub))
		     (send this print "makeview:")(newline)
		     (send this print (send ub get-name))(newline)
		     (send this print (send ub get-passwd))(newline)
		     (send this print (send ub int-to-string (send ub get-age)))(newline)))
      (class mystring object 
	     (field string str)
	     (method void   init        ()           (super init))
	     (method void   set-string! ((string s)) (fset! this str s))
	     (method string get-string  ()           (fget  this str))
	     (method string dirty       ((string s)) s))
      (class bean object 
	     (field string str)
	     (method void   init          ()           (super init))
	     (method void   set-input!    ((string s)) (fset! this str s))
	     (method string get-input     ()           (fget  this str))
	     (method string get-string    ((string s)) s)
	     (method string string-append ((string s1) (string s2)) (string-append s1 s2))
	     (method string sanitizing    ((string s)) (string-append "not " s)))
      (class msbean object 
	     (field mystring mystr)
	     (method void     init       ()              (super init))
	     (method void     set-ms!    ((mystring ms)) (fset! this mystr ms))
	     (method mystring get-ms     ()              (fget this mystr))
	     (method string   get-string ()              (send (fget this mystr)
							       get-string))
	     (method void     dirty      ()              '()))
      (class listbean object 
	     (field string str)
	     (field listbean lb)
	     (method void     init        ()             (super init))
	     (method void     set-lb!     ((listbean l)) (fset! this lb l))
	     (method listbean get-lb      ()             (fget this lb))
	     (method void     set-string! ((string s))   (fset! this str s))
	     (method string   get-string  ()             (fget this str))
	     (method void     dirty       ()             '()))
      (class userbean object 
	     (field string name)
	     (field string passwd)
	     (field int    age)
	     (field string address)
	     (method void    init          ()           (super init))
	     (method void    set-name!     ((string n)) (fset! this name n))
	     (method string  get-name      ()           (fget  this name))
	     (method void    set-passwd!   ((string p)) (fset! this passwd p))
	     (method string  get-passwd    ()           (fget  this passwd))
	     (method void    set-age!      ((int a))    (fset! this age a))
	     (method string  get-age       ()           (fget  this age))
	     (method int     string-to-int ((string i)) 23)
	     (method string  int-to-string ((int s))    (number->string s))
	     (method void    dirty         ()           '())))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; return 

(add-test 'return01
	  "returns"
	  '((class main object 
		   (method void init () (super init))
		   (method int main () 1)
		   (after () (and (call main) (return (int r)))
			  (write 'return)
			  (newline))))
	  1
	  '(return NL))


		   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; dflow

(add-test 'dflow01
	  "dflow on the same value"
	  '((class main object
		   (method void init () (super init))
		   (method int main ()
			   (send this foo (new main))
			   0)
		   (method main foo ((main x)) (send this bar x))
		   (method main bar ((main x)) x)
		   ;; when the argument to bar is in the dataflow of the argument of foo
		   (after () (dflow x (and (call bar) (args (main x)))
				 y (and (call foo) (args (main y))))
		    (write 'dflow)
		    (newline))))
	  0
	  '(dflow NL))

(add-test 'dflow02
	  "dflow on the same primitive value"
	  '((class main object 
		   (method void init () (super init))
		   (method int main () (send this foo 1))
		   (method int foo ((int v)) (send this bar v))
		   (method int bar ((int v)) v)
		   (after () (dflow x (and (call bar) (args (int x)))
				 y (and (call foo) (args (int y))))
			  (write 'bar-arg-depends-on-foo-arg)
			  (newline))))
	  1
	  '(bar-arg-depends-on-foo-arg NL))

(add-test 'dflow03
	  "dflow with return"
	  '((class main object 
		   (method void init () (super init))
		   (method int main () (send this foo (send this bar 1)))
		   (method int foo ((int v)) v)
		   (method int bar ((int v)) v)
		   (after () (dflow y (and (call foo) (args (int y)))
				 x (and (call bar) (return (int x))))
			  (write 'foo-arg-depends-on-bar-return)
			  (newline))))
	  1
	  '(foo-arg-depends-on-bar-return NL))

(add-test 'dflow04
	  "dflow on the value produced by primitive operations"
	  '((class main object 
		   (method void init () (super init))
		   (method int main () (send this foo 1))
		   (method int foo ((int v)) (send this bar (+ v v)))
		   (method int bar ((int v)) v)
		   (after () (dflow x (and (call bar) (args (int x)))
				 y (and (call foo) (args (int y))))
			  (write 'bar-arg-depends-on-foo-arg)
			  (newline))))
	  2
	  '(bar-arg-depends-on-foo-arg NL))


;(add-test 'dflow02
;	  "dflow on the same value 2"
;	  '((class main object
;		   (method void init () (super init))
;		   (method int main ()
;			   (let (((c obj) (new c)))
;			     (send obj setc (send this foo (new c)))
;			     (send this bar (send obj getc))
;			     (send this bar obj)
;			     0))
;		   (method void foo ((c obj)) obj)
;		   (method void bar ((c obj)) obj)
;		   ;; when the argument to bar is in the dataflow of the argument of foo
;		   (after () (dflow x (and (call bar) (args (main x)))
;				 y (and (call foo) (args (main y))))
;		    (write 'dflow)
;		    (newline)))
;	    (class c object
;		   (field c v)
;		   (method void init () (super init))
;		   (method void setc ((c v)) (fset! this v v))
;		   (method void getc () (fget this v))))
;	    0
;	    '(dflow NL))

;(add-test 'dflow03
;	  "dflow on the same value 2"
;	  '((class main object
;		   (method void init () (super init))
;		   (method int main ()
;			   (let (((c obj) (new c)))
;			     (send obj setc (new c))

;			     (let (((c sub-obj)  (send obj getc)))
;			       (send this foo obj) ; mark obj 

;			       (send this bar sub-obj) ; is this in dflow?
;			       (send this bar obj) ; this is in dflow
;			       0)))
;		   (method void foo ((c obj)) obj)
;		   (method void bar ((c obj)) obj)
;		   ;; when the argument to bar is in the dataflow of the argument of foo
;		   (after () (dflow x (and (call bar) (args (main x)))
;				 y (and (call foo) (args (main y))))
;		    (write 'dflow)
;		    (newline)))
;	    (class c object
;		   (field c v)
;		   (method void init () (super init))
;		   (method void setc ((c v)) (fset! this v v))
;		   (method void getc () (fget this v))))
;	    0
;	    '(dflow NL))


(add-test 'dflow05
	   "sanitizing with dflow" 
	   (cons '(class main object 
			 (method void init () (super init))
			 (method void main ()
				 (let (((view v) (new view)))
				   (let (((string s) (send v input)))
				     (send v makeview s)
				     0)))
			 (after () (dflow x (and (call print) (args   (string x)))
				       y (and (call input) (return (string y))))
				(write 'dflow)(newline)))
		 (view-and-bean-class-decls))
	   0
	   '("makeview:" NL "dirty" dflow NL NL))

(add-test 'dflow06
	   "sanitizing a string modified by string-append"
	   (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v) (new view)))
				  (let (((string s) (string-append "less " (send v input))))
				    (send v makeview s)
				    0)))
			(after () (dflow x (and (call print) (args   (string x)))
				      y (and (call input) (return (string y))))
			       (write 'dflow)(newline)))
		 (view-and-bean-class-decls))
	   0
	   '("makeview:" NL "less dirty" dflow NL NL))

(add-test 'dflow07
	   "sanitizing with dflow+around"
	   (cons '(class main object 
			 (method void init () (super init))
			 (method void main ()
				 (let (((view v) (new view)))
				   (let (((string s) (send v input)))
				     (send v makeview s)
				     0)))
			 (around ((string w) (string x))
				 (and (args  (string w))
				      (dflow x (and (call print) (args   (string x)))
					     y (and (call input) (return (string y)))))
				 (proceed "clean string" x)))
		 (view-and-bean-class-decls))
	   0
	   '("makeview:" NL "clean string" NL))

(add-test 'dflow08
	  "dflow - data from object's field (after)"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v) (new view))
				      ((bean b) (new bean)))
				  (send b set-input! (send v input))
				  (send v makeview (send b get-input))
				  0))
			(after () (dflow x (and (call print) (args   (string x)))
				      y (and (call input) (return (string y))))
			       (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "dirty" after NL))


(add-test 'dflow09
	  "dflow - data from object's field (around)"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v) (new view))
				      ((bean b) (new bean)))
				  (send b set-input! (send v input))
				  (send v makeview (send b get-input))
				  0))
			(around ((string w) (string x)) (and (args  (string w))
				     (dflow x (and (call print) (args   (string x)))
					    y (and (call input) (return (string y)))))
				(proceed "clean string" x)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "clean string" NL))

(add-test 'dflow10
	  "dflow - crosscut concerns"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v1) (new view))
				      ((view v2) (new view))
				      ((bean b)  (new bean)))
				  (send b set-input! (send v1 input))
				  (send v2 makeview (send b get-input))
				  0))
			(after () (dflow x (and (call print) (args   (string x)))
				      y (and (call input) (return (string y))))
			       (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "dirty" after NL))

(add-test 'dflow11
	  "dflow - using 'or' operation in src-pcd"
	  (cons '(class main object 
		  (method void init () (super init))
		  (method void main ()
		   (let (((view v1) (new view))
			 ((view v2) (new view))
			 ((bean b)  (new bean)))
		     (send v1 makeview   (send b get-string "from bean"))
		     (send b  set-input! (send v1 input))
		     (send v2 makeview   (send b get-input))
		     0))
		  (after () (dflow x (and      (call print)       (args   (string x)))
				   y (or  (and (call input)       (return (string y)))
					  (and (call get-string)  (args   (string y)))))
		    (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "from bean" after NL 
	    "makeview:" NL "dirty" after NL))


(add-test 'bypass01
	  "bypassing - a return value"
	  (cons '(class main object 
		   (method void init () (super init))
		   (method void main ()
			   (let (((view v1) (new view))
				 ((bean b)  (new bean)))
			     (send b  set-input! (send v1 input))
			     (let (((string out) (send b get-input)))
			       (send v1 makeview (send b sanitizing out))
			       (send v1 makeview out)
			       0)))
		   (after () (dflow     x (and (call print)      (args   (string x)))
				        y (and (call input)      (return (string y)))
			      bypassing z (and (call sanitizing) (return (string z))))
			       (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "not dirty" NL 
	    "makeview:" NL "dirty" after NL))

(add-test 'bypass02
	  "bypassing - an argument"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v1) (new view))
				      ((bean b)  (new bean)))
				  (send b  set-input! (send v1 input))
				  (let (((string out) (send b get-input)))
				    (send v1 makeview (send b sanitizing out))
				    (send v1 makeview out)
				    0)))
			(after () (dflow     x (and (call print)      (args   (string x)))
				             y (and (call input)      (return (string y)))
				   bypassing z (and (call sanitizing) (args   (string z))))
			       (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "not dirty" NL 
	    "makeview:" NL "dirty" NL))

(add-test 'bypass03
	  "bypassing - a case of bypassing of 'sanitizing' is possible."
	  (cons '(class main object 
		   (method void init () (super init))
		   (method void main ()
		     (let (((view v1) (new view))
			   ((bean b)  (new bean)))
		       (send b set-input! (send v1 input))
		       (let (((string out1) (send b get-input))
			     ((string out2) (send b get-input)))
			 (send v1 makeview (string-append (send b sanitizing out1)
							  out2))
			 0)))
		   (after () (dflow     x (and (call print)      (args   (string x)))
				        y (and (call input)      (return (string y)))
			      bypassing z (and (call sanitizing) (return (string z))))
		     (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "not dirtydirty" after NL))

(add-test 'bypass04
	  "bypassing - remark 'dflow-id'"
	  (cons
	   '(class main object 
	      (method void init () (super init))
	      (method void main ()
		      (let (((view v1) (new view))
			    ((bean b)  (new bean)))
			(send b set-input! (send v1 input))
			(let (((string out1) (send b get-input)))
			  (let (((string out2) (send b sanitizing out1)))
			    (send v1 makeview out2) 
			    (send v1 makeview (send b get-string out2))
			    0))))
	      (after () (dflow     x (and     (call print)      (args   (string x)))
				   y (or (and (call input)      (return (string y)))
					 (and (call get-string) (args   (string y))))
			 bypassing z (and     (call sanitizing) (return (string z))))
		(write 'after)))
	   (view-and-bean-class-decls))
	  0
	  '("makeview:" NL "not dirty" NL 
	    "makeview:" NL "not dirty" after NL))
			       
(add-test 'bypass05
	  "bypassing - remark 'dflow-id' 2"
	  (cons '(class main object 
		   (method void init () (super init))
		   (method void main ()
			   (let (((view v1) (new view))
				 ((bean b)  (new bean)))
			     (send b set-input! (send v1 input))
			     (let (((string out1) (send b get-input)))
			       (let (((string out2) (send b sanitizing out1)))
				 (send v1 makeview out2) 
				 (send v1 makeview (send b get-string out2))
				 (send v1 makeview out2) 
				 0))))
		   (after () (dflow     x (and (call print)          (args   (string x)))
					y (or (and (call input)      (return (string y)))
					      (and (call get-string) (args   (string y))))
			      bypassing z (and     (call sanitizing) (args   (string z))))
		     (write 'after)))
		(view-and-bean-class-decls))
	  0
	  '("makeview:" NL "not dirty" NL 
	    "makeview:" NL "not dirty" after NL 
	    "makeview:" NL "not dirty" after NL))

(add-test 'dflow12
	  "dflow - args or target"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v1) (new view))
				      ((bean b)  (new bean)))
				  (send b  set-input! (send v1 input))
				  (let (((mystring out1) (new mystring "out1")))
				    (let (((mystring out2) (new mystring "out2")))
				      (send out1 dirty!)
				      (send out2 dirty!)
				      (send v1 makeview (send out1 cat out2))
				      (send v1 makeview (send out2 cat out1))
				      0))))
			(after () (dflow x (and (call cat) (or (args (mystring x))
							    (target (mystring x))))
				      y (and (call dirty!)  (target (mystring y))))
			       (write (send x gets))
			       (write 'cat)))
		(cons '(class mystring object
			      (field  string str)
			      (method void init ((string s))
				      (fset! this str s))
			      (method void dirty! ())
			      (method string gets ()
				      (fget this str))
			      (method string cat ((mystring s))
				      (string-append (send this gets) (send s gets))))
		      (view-and-bean-class-decls)))
	  0
	  '("out2" cat "makeview:" NL "out1out2" NL
	    "out1" cat "makeview:" NL "out2out1" NL))

(add-test 'dflow12ex
	  "dflow - target or args"
	  (cons '(class main object 
			(method void init () (super init))
			(method void main ()
				(let (((view v1) (new view))
				      ((bean b)  (new bean)))
				  (send b  set-input! (send v1 input))
				  (let (((mystring out1) (new mystring "out1")))
				    (let (((mystring out2) (new mystring "out2")))
				      (send out1 dirty!)
				      (send out2 dirty!)
				      (send v1 makeview (send out1 cat out2))
				      (send v1 makeview (send out2 cat out1))
				      0))))
			(after () (dflow x (and (call cat) (or (target (mystring x))
							    (args   (mystring x))))
				      y (and (call dirty!)  (target (mystring y))))
			       (write (send x gets))
			       (write 'cat)))
		(cons '(class mystring object
			      (field  string str)
			      (method void init ((string s))
				      (fset! this str s))
			      (method void dirty! ())
			      (method string gets ()
				      (fget this str))
			      (method string cat ((mystring s))
				      (string-append (send this gets) (send s gets))))
		      (view-and-bean-class-decls)))
	  0
	  '("out1" cat "makeview:" NL "out1out2" NL
	    "out2" cat "makeview:" NL "out2out1" NL))

; (add-test 'dflow13
; 	    "dflow - nested dflow"
; 	    (cons '(class main object 
; 			  (method void init () (super init))
; 			  (method void main ()
; 				  (let (((view v1) (new view))
; 					((bean b)  (new bean)))
; 				    (send b  set-input! (send v1 input))
; 				    (let (((string out) (send b  get-input)))
; 				      (send v1 makeview out)
; 				      (send v1 makeview (send b get-string out))
; 				      0)))
; ;			(after () (and (call set-input!) (target (bean y))) ;; test
; ;			       (write (send y get-input))))              ;; 
; 			  (after () (dflow x (and (call print) (args   (string x))) ;; goal
; 					y (dflow y (and (call get-string) (return (string y)))
; 						 z (and (call input)      (return (string z)))))  ;;
; 				 (write 'after)))
; 		  (view-and-bean-class-decls))
; 	    0
; 	    '("makeview:" NL "dirty" after NL
; 	      "makeview:" NL "dirty" after NL))
; 
(add-test 'have-a01
	    "dflow - 'have-a' relation"
	    (cons '(class main object 
			  (method void init () (super init))
			  (method void main ()
				  (let (((view v1) (new view))
					((bean b)  (new bean)))
				    (send b  set-input! (send v1 input))
				    (send b  get-string "hoge")
				    (send v1 makeview   (send b  get-input))
				    0))
			  (after () (dflow x (and (call print)      (args   (string x))) ;; goal
					y (and (call get-string) (target (bean y))))  ;;
				 (write 'after)))
		  (view-and-bean-class-decls))
	    0
	    '("makeview:" NL "dirty" after NL))   ;; goal

; (add-test 'have-a02
; 	    "dflow - 'have-a' relation 2 - fail : 'or' problem" ;; because of the timing of propagation and marking.
; 	    (cons '(class main object 
; 			  (method void init () (super init))
; 			  (method void main ()
; 				  (let (((view v1) (new view))
; 					((bean b)  (new bean)))
; 				    (send b  set-input! (send v1 input))
; 				    (send v1 makeview   (send b  get-input))
; 				    0))
; 			  (after () (dflow x (and (call print)      (args   (string x)))
; 					y (and (call set-input!) (target (bean y)))) 
; 				 (write 'after)))
; 		  (view-and-bean-class-decls))
; 	    0
; 	    '("makeview:" NL "dirty" after NL))   ;; fail

(add-test 'have-a03
	    "dflow - 'have-a' relation for mystring"
	    (cons '(class main object 
			  (method void init () (super init))
			  (method void main ()
				  (let (((view v1)     (new view))
					((msbean msb)  (new msbean))
					((mystring ms) (new mystring)))
				    (send ms  set-string! (send v1 input))
				    (send msb set-ms! ms)
				    (send msb dirty)
				    (send v1  makeview (send msb get-string))
				    0))
			  (after () (dflow x (and (call print) (args   (string x)))
					y (and (call dirty) (target (msbean y)))) 
				 (write 'after)))
		  (view-and-bean-class-decls))
	    0
	    '("makeview:" NL "dirty" after NL))

(add-test 'have-a04
	    "dflow - circular 'have-a' relation"
	    (cons '(class main object 
			  (method void init () (super init))
			  (method void main ()
				  (let (((view v1)      (new view))
					((listbean lb1) (new listbean))
					((listbean lb2) (new listbean))
					((string s)     "not dirty?"))
				    (send lb1  set-string! (send v1 input))
				    (send lb2  set-string! s)
				    (send lb1  set-lb! lb2)
				    (send lb2  set-lb! lb1)
				    (send lb1 dirty)
				    (send v1  makeview (send lb2 get-string))
				    0))
			  (after () (dflow x (and (call print) (args   (string x)))
					y (and (call dirty) (target (listbean y)))) 
				 (write 'after)))
		  (view-and-bean-class-decls))
	    0
	    '("makeview:" NL "not dirty?" after NL))

(add-test 'sanitize01
	    "dflow - sanitize : userbean"
	    (cons '(class main object 
			  (method void init () (super init))
			  (method void main ()
				  (let (((view v1)       (new view))
					((userbean ub)   (new userbean)))
				    (send ub set-name!    (send v1 input))
				    (send ub set-passwd!  (send v1 input))
				    (send ub set-age!     (send ub string-to-int (send v1 input)))
				    (send ub dirty)
				    (send v1  makeview-with-userbean ub)
				    0))
			  (after () (dflow x (and (call print) (args   (string x)))
					y (and (call dirty) (target (msbean y)))) 
				 (write 'after)))
		  (view-and-bean-class-decls))
	    0
	    '("makeview:" NL "dirty" after NL "dirty" after NL "23" after NL))

(add-test 'sanitize02
	    "dflow - sanitize : string append with bypassing"
	    (cons '(class main object 
			  (method void init () (super init))
			  (method void main ()
				  (let (((view v1)       (new view))
					((string temp1)  "temp1 : ")
					((string temp2)  " : temp2")
					((bean b)        (new bean)))
				    (send b  set-input! (send v1 input))
				    (let (((string r1) (send b string-append temp1 (send b get-input))))
				      (let (((string r2) (send b string-append r1 temp2)))
					(send v1 makeview r2)
					0))))
			  (before () (and (dflow x (and (call string-append) (args   (string x) (string str)))
					      y (and (call input)         (return (string y)))
					      bypassing z (and (call sanitizing) (args (string z))))
				       (target (bean b)))
				  (let (((view v) (new view))
					((string s) (send b sanitizing x)))
				    (send v print s)
				    (write 'before)
				    (newline)))
			  (after () (dflow x (and (call print) (args   (string x)))
					y (and (call input) (return (string y)))
					bypassing z (and (call sanitizing) (args (string z))))
				 (write 'after)))
		  (view-and-bean-class-decls))
	    0
;	    '("not dirty" before NL "makeview:" NL "temp1 : dirty : temp2" NL)) ;; goal
	    '("not temp1 : dirty" before NL "makeview:" NL "temp1 : dirty : temp2" NL))

; (add-test 'sanitize03
; 	      "dflow - sanitize : string append with bypassing 2"
; 	      (cons '(class main object 
; 			    (method void init () (super init))
; 			    (method void main ()
; 				    (let (((view v1)       (new view))
; 					  ((string temp1)  " : temp1 : ")
; 					  ((string temp2)  " : temp2")
; 					  ((bean b1)        (new bean))
; 					  ((bean b2)        (new bean)))
; 				      (send b1  set-input! (send v1 input))
; 				      (send b2  set-input! (send v1 input))
; 				      (let (((string r1) (send b1 string-append (send b1 get-input) temp1)))
; 					(let (((string r2) (send b1 string-append r1 (send b2 get-input))))
; 					  (let (((string r3) (send b1 string-append r2 temp2)))
; 					    (send v1 makeview r3)
; 					    0)))))
; 			    (around ((string x) (string str)) 
; 				    (and (dflow x (and (call string-append) (args   (string x) (string str)))
; 						y (and (call input)         (return (string y)))
; 						bypassing z (and (call sanitizing) (return (string z))))
; 					 (target (bean b)))
; 				    (let (((view v) (new view))
; 					  ((string s) (send b sanitizing x)))
; 				      (send v print s) ;; print "not dirty" 
; 				      (write 'around1) ;; print 'around1
; 				      (newline)        ;; print newline
; 				      (proceed s str)))
; 			    (around ((string str) (string x)) 
; 				    (and (dflow x (and (call string-append) (args   (string str) (string x)))
; 						y (and (call input)         (return (string y)))
; 						bypassing z (and (call sanitizing) (return (string z))))
; 					 (target (bean b)))
; 				    (let (((view v) (new view))
; 					  ((string s) (send b sanitizing x)))
; 				      (send v print s)
; 				      (write 'around2)
; 				      (newline)
; 				      (proceed str s)))
; 			    (after () (dflow x (and (call print) (args   (string x)))
; 					  y (and (call input) (return (string y)))
; 					  bypassing z (and (call sanitizing) (args (string z))))
; 				   (write 'after)))
; 		    (view-and-bean-class-decls))
; 	      0
; 	      '("not dirty" around1 NL "not dirty" around2 NL "makeview:" NL "not dirty : temp1 : not dirty : temp2" NL)) ;; goal
; ;	    '("not temp1 : dirty" before NL "makeview:" NL "temp1 : dirty : temp2" NL))

(add-test 'sanitize04
  "dflow - sanitize : string append with bypassing 2"
  (cons '(class main object 
	   (method void init () (super init))
	   (method void main ()
	     (let (((view v1)       (new view))
		   ((string temp1)  "temp1 : ")
		   ((string temp2)  " : temp2")
		   ((bean b1)        (new bean)))
	       (send b1  set-input! (send v1 input))
	       (let (((string r1) (send b1 string-append temp1
					(send b1 get-input))));; temp1 + dirty
		 (let (((string r2)
			(send b1 string-append r1 temp2)));; (temp1+"not"dirty) + temp2
		   (send v1 makeview r2);; print (temp1+"not"dirty)+temp2
		   0))))
	   (around ((string x) (string str))
	     (and (dflow     x (and (call string-append) (args   (string x) (string str)))
			     y (and (call input)         (return (string y)))
		   bypassing z (and (call sanitizing)    (return (string z))))
		  (target (bean b)))
	     (let (((view v) (new view))
		   ((string s) (send b sanitizing x)))
	       (send v print s) 
	       (write 'around1) 
	       (newline)        
	       (proceed s str)))
	   (around ((string str) (string x))
	     (and (dflow     x (and (call string-append) (args   (string str) (string x)))
			     y (and (call input)         (return (string y)))
		   bypassing z (and (call sanitizing)    (return (string z))))
		  (target (bean b)))
	     (let (((view v) (new view))
		   ((string s) (send b sanitizing x)))
	       (send v print s)
	       (write 'around2)
	       (newline)
	       (proceed str s)))
	   (after () (dflow x (and (call print) (args   (string x)))
			    y (and (call input) (return (string y)))
			    bypassing z (and (call sanitizing) (args (string z))))
		  (write 'after)))	;this should not happen
	(view-and-bean-class-decls))
  0
  '("not dirty" around2 NL "makeview:" NL "temp1 : not dirty : temp2" NL)) ;; goal
